#!/bin/bash
#
# remove all object files and containing libraries such that
# compilation is forced for all source files containing checked vectorization!
#
# for details about vectorization see ./vectorize.README

# ./vectorized.source
SOURCELIST=$ARBHOME/SOURCE_TOOLS/vectorized.source
SED=${ARBHOME}/SH/arb_sed
DIRS2CLEAN=`cat $SOURCELIST | grep -v '^#' | $SED -e 's/\/[^\/]*$//' | sort | uniq`
OBJS2CLEAN=`cat $SOURCELIST | grep -v '^#' | $SED -e 's/\.cxx$/\.o/' | grep '.o$'`

cd ${ARBHOME}

for obj in $OBJS2CLEAN; do
    rm -f $obj
done

for dir in $DIRS2CLEAN; do
    rm -f $dir/*.a $dir/*.so
done

